/*
 * Created on 17-Nov-2004
 */
package kenya;

/**
 * @author Thomas Timbul
 */
public final class KenyaCore {
	
	public static final String NEWLINE = System.getProperty("line.separator");
	
	private KenyaCore() {}
	
	public static void printError(String message) {
		System.err.println("Kenya:  " + message);
		System.err.println();
		System.exit(1);
	}
	
	public static void printLicense() {
		System.out.println(LICENSE);
	}
	
	public static final String LICENSE =
		NEWLINE
		+ "   Kenya"
		+ NEWLINE
		+ "   Copyright (C) 2004 Tristan Allwood,"
		+ NEWLINE
		+ "                 2004 Matthew Sackman"
		+ NEWLINE
		+ NEWLINE
		+ "   This program is free software; you can redistribute it and/or"
		+ NEWLINE
		+ "   modify it under the terms of the GNU General Public License"
		+ NEWLINE
		+ "   as published by the Free Software Foundation; either version 2"
		+ NEWLINE
		+ "   of the License, or (at your option) any later version."
		+ NEWLINE
		+ NEWLINE
		+ "   This program is distributed in the hope that it will be useful,"
		+ NEWLINE
		+ "   but WITHOUT ANY WARRANTY; without even the implied warranty of"
		+ NEWLINE
		+ "   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the"
		+ NEWLINE
		+ "   GNU General Public License for more details."
		+ NEWLINE
		+ NEWLINE
		+ "   You should have received a copy of the GNU General Public License"
		+ NEWLINE
		+ "   along with this program; if not, write to the Free Software"
		+ NEWLINE
		+ "   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA."
		+ NEWLINE + NEWLINE
		+ "   The authors can be contacted by email at toa02@doc.ic.ac.uk"
		+ NEWLINE
		+ "                                             ms02@doc.ic.ac.uk"
		+ NEWLINE;
	
	public static final String commonhelp1 =
		NEWLINE
		+ "Kenya: 	A teaching language designed by Tristan Allwood and Matthew Sackman (c) 2004."
		+ NEWLINE
		+ "        Based upon work previously done by Robert Chatley and others, in 2001"
		+ NEWLINE
		+ NEWLINE
		+ "Usage:";
	
	public static final String optionshelp =
		NEWLINE
		+ "-s|--translate         Translate the Kenya program to Java if it is valid"
		+ NEWLINE
		+ "-c|--execute <path>    Execute the Kenya program, using Path as a place to save "
		+ NEWLINE
		+ "                           the .java and .class file"
		+ NEWLINE
		+ "-i|--interpret         Interpret the Kenya program"
		+ NEWLINE
		+ "-h|--help              Show this help message."
		+ NEWLINE
		+ "-d|--debug             Print out debugging information."
		+ NEWLINE
		+ "-p|--parse             Stop after the parsing stage."
		+ NEWLINE
		+ "-f|--typefind          Stop after the type-finding stage."
		+ NEWLINE
		+ "-e|--definitionfind    Stop after the definition finding stage."
		+ NEWLINE
		+ "-l|--builtinload       Stop after the built-in method loading stage."
		+ NEWLINE
		+ "-t|--typecheck         Stop after the type-checking stage."
		+ NEWLINE
		+ "-y|--structcheck       Stop after the variable-value checking stage."
		+ NEWLINE
		+ "-n|--license           Show the licensing information for Kenya."
		+ NEWLINE;

	public static final boolean DEBUG_OUTPUT = new Boolean(System.getProperty(
	"KENYA_DEBUG", "false")).booleanValue();
	
	
}
