/* *******************************************************************************
 *   Kenya                                                                       *
 *   Copyright (C) 2004 Tristan Allwood,                                         *
 *                 2004 Matthew Sackman                                          *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The authors can be contacted by email at toa02@doc.ic.ac.uk                 *
 *                                             ms02@doc.ic.ac.uk                 *
 *                                                                               *
 *********************************************************************************/

/*
 * Created on 01-Jul-2004
 *
 */
package kenya.builtIns;

import java.util.Set;


/**
 * This is implemented by the built in method classes, thus aiding the way in
 * which those classes publish the methods they support.
 * 
 * @author Matthew Sackman
 * @version 1
 */
public interface IBuiltInMethodFactory {

    public static final String LOCATION = IBuiltInMethodFactory.class.getName();

    /**
     * Returns the name of this BuiltInMethod.
     * 
     * @return The name of this BuiltInMethod.
     */
    String getName();

    /**
     * Returns a Set of AbstractBuiltInMethod instances each of which represent
     * a method call that is callable.
     * @return A Set of AbstractBuildInMethod instances
     */
    Set buildMethods();

}