/* *******************************************************************************
 *   kenya                                                             *
 *   Copyright (C) 2004 Tristan Allwood,                                         *
 *                 2004 Matthew Sackman                                          *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The authors can be contacted by email at toa02@doc.ic.ac.uk                 *
 *                                             ms02@doc.ic.ac.uk                 *
 *                                                                               *
 *********************************************************************************/
/*
 * Created on 26-Aug-2004
 */
package kenya.builtIns;

import org.wellquite.kenya.stackMachine.InterpretedClass;
import org.wellquite.kenya.stackMachine.StackMachine;
import org.wellquite.kenya.stackMachine.types.AbstractAtomicClosure;
import org.wellquite.kenya.stackMachine.types.interfaces.IInterpretedClass;
import org.wellquite.kenya.stackMachine.types.interfaces.IInterpretedMethod;

/**
 * @author Matthew Sackman (ms02)
 * @version 1
 */
public class SMLibraryContainer {

    private static SMLibraryContainer singleton = null;

    public static SMLibraryContainer getLibrary() {
        if (singleton == null)
            singleton = new SMLibraryContainer();
        return singleton;
    }

    private final IInterpretedClass libraryClass = new InterpretedClass(
            "SMLibrary");

    public synchronized void addStaticMethod(IInterpretedMethod method) {
        libraryClass.addStaticMethod(method);
    }
    
    public IInterpretedClass getLibraryClass() {
        return libraryClass;
    }

    public synchronized AbstractAtomicClosure invokeBuiltInMethod(final IInterpretedMethod method) {
        return new AbstractAtomicClosure() {

            public void execute(StackMachine sm) {
                sm.invokeMethod(libraryClass, method.getName());
            }
            
            public String toString() {
                return "invoke built in method " + method.getName();
            }
        };
    }
}