/* *******************************************************************************
 *   Kenya                                                                       *
 *   Copyright (C) 2004 Tristan Allwood,                                         *
 *                 2004 Matthew Sackman                                          *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The authors can be contacted by email at toa02@doc.ic.ac.uk                 *
 *                                             ms02@doc.ic.ac.uk                 *
 *                                                                               *
 *********************************************************************************/

/*
 * Created on 20-Jul-2004 by toa02
 *
 */
package kenya.sourceCodeInformation.interfaces;

import java.io.StringReader;


/**
 * @author toa02
 *
 */
public interface ISourceCodeInformation {
    
    /**
     * @return String human style "error" message for this information.
     */
    public StringReader getHumanStyleMessage();

    
    /**
     * @return Gives back the location of this "information"
     */
    public ISourceCodeLocation getLocation();
    
    /**
     * @returnAn array of the linked information
     */
    public ISourceCodeLocation[] getLinkedInformation();
    
    /**
     * @return int the information number of this information (helps for debugging!)
     */
    public int getInformationNumber();
    
    
}