/* *******************************************************************************
 *   Kenya                                                                       *
 *   Copyright (C) 2004 Tristan Allwood,                                         *
 *                 2004 Matthew Sackman                                          *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The authors can be contacted by email at toa02@doc.ic.ac.uk                 *
 *                                             ms02@doc.ic.ac.uk                 *
 *                                                                               *
 *********************************************************************************/


/*
 * Created on 20-Jul-2004 by toa02
 *
 */
package kenya.sourceCodeInformation.interfaces;

/**
 * @author toa02
 *
 */
public interface ISourceCodeLocation {

    /**
     * @return int representing the line number this 
     * "Source Code" is on.
     */
    public int getLineNumber();
    
    /**
     * @return int representing the column in 
     * the current line that this source code location is on.
     */
    public int getColumnNumber();
    
    /**
     * @return int representing the length of the token.
     */
    public int getTokenLength();
}
