/* *******************************************************************************
 *   Kenya                                                                       *
 *   Copyright (C) 2004 Tristan Allwood,                                         *
 *                 2004 Matthew Sackman                                          *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The authors can be contacted by email at toa02@doc.ic.ac.uk                 *
 *                                             ms02@doc.ic.ac.uk                 *
 *                                                                               *
 *********************************************************************************/

/*
 * Created on 22-Jul-2004
 */
package org.wellquite.kenya.stackMachine.types.interfaces;

/**
 * @author Matthew Sackman (ms02)
 * @version 1
 */
public interface IInterpretedEnumeration {

    /**
     * Get the available values contained within this enumeration.
     * 
     * @return
     */
    Object[] getValues();

    /**
     * Set the available values contained within this enumeration.
     * 
     * @param values
     */
    void setValues(Object[] values);

    /**
     * Is the supplied value a value contained within this enumeration?
     * 
     * @param value
     *            The value to test.
     * @return true iff the value is a value contained within this enumeration.
     */
    boolean isValidValue(Object value);

    /**
     * Sets the enumeration's name.
     * 
     * @param name
     */
    void setName(String name);

    /**
     * Gets the enumeration's name.
     * 
     * @return
     */
    String getName();
}